package main

import (
	crand "crypto/rand"
	"os"

	"codeberg.org/gruf/go-ulid"
)

func main() {
	// Take timestamp
	now := ulid.Now()

	// Use safe rand source
	entropy := crand.Reader

	// Create monotonic reader from entropy source
	reader, err := ulid.NewMonotonicReader(entropy)
	if err != nil {
		panic(err)
	}

	var ulid ulid.ULID

	// Read next ULID from monotonic reader
	if err := reader.Next(now, &ulid); err != nil {
		panic(err)
	}

	// Write ULID to stdout
	str := ulid.String() + "\n"
	os.Stdout.WriteString(str)
}
